#!/usr/bin/perl

# Perl Guestbook v1.1 
# 2008-2011 (C) Alexander Yanitsky 
# web site: janicky.com                          
# e-mail: janickiy@mail.ru
# ICQ: 305-972                     

use DBI;
use URI::Escape;
use POSIX;
use Digest::MD5  qw(md5 md5_hex md5_base64);
use CGI qw(:standard);
use CGI::Carp 'fatalsToBrowser';
  
use Constants;

#   
require 'lib/_function.pl' or die('   "_function.pl"');
  
my $cod = getRandomCod();
my $id_session = cookie('id_session');
$id_session = invert_comas($id_session); 
  
if($id_session eq '')
{
   $c = cookie( -name  => 'id_session',
                -value => "$cod");
   $id_session = $cod;			  
   print header(-type=>"text/html;charset=".Constants::CHARSET."", -cookie => $c);	
}
else
{
   $c = cookie( -name  => 'id_session',
                -value => "$id_session");
   print header(-type=>"text/html;charset=".Constants::CHARSET."", -cookie => $c);  
}
  
use ConnectDB;
use GetSetting;

#  
$title = "  Perl Guestbook -  ";
$description = '';
$keywords = '';
  
#  ip 
if($ENV{'HTTP_X_FORWARDED_FOR'}) 
{
  $ip = $ENV{'HTTP_X_FORWARDED_FOR'};
} 
else 
{
  $ip = $ENV{'REMOTE_ADDR'};
}

my @error = ();

$error[1] = '';
$error[2] = '';
$error[3] = '';
$error[4] = '';
$error[5] = '';

my $action = "";

$action = param("action");

#    param     POST
my $msg          = param("msg");
my $name         = param("name");
my $email        = lc(param("email"));
my $city         = param("city");
my $url          = lc(param("url"));
my $securityCode = param("securityCode");
  
if($action ne '')
{
	
   #      
   $name         = trim(htmlspecialchars($name));
   $email        = trim(htmlspecialchars($email));
   $url          = trim(htmlspecialchars($url));
   $msg          = trim(htmlspecialchars($msg));
   $city         = trim(htmlspecialchars($city));
   $securityCode = trim($securityCode);

   #   http://  $url
   if($url ne '')
   {  
      if((substr($url, 0, 7)) eq "http://") { $url =~ s/http:\/\///g; }
      if((substr($url, 0, 4)) eq "www.") { $url =~ s/www\.//g; }
   }

   #      
   if($email ne '')
   {
      if($email !~ /^[-0-9a-z_\.]+@[-0-9a-z_\.]+\.(?:com|edu|gov|int|mil|net|org|biz|info|museum|coop|name|aero|mobi|travel|pro|[a-z][a-z])$/i)
      {
         $action = "";
         $error[3] = $error[3]."  -mail.</i>";
      }
   }

   #    url 
   if($url ne '')
   {
      if($url !~ /^(?:http:\/\/)?[-0-9a-z_\.]+\.(?:com|edu|gov|int|mil|net|org|biz|info|museum|coop|name|aero|mobi|travel|pro|[a-z][a-z])$/i)
      {
         $action = "";
         $error[4] = $error[4]."  url .";
      }
   }

   #     
   if($row_setting->{security} eq 'yes' and $securityCode ne '')
   {
      my $query = $dbh->prepare("SELECT * FROM ".Constants::DB_CAPTCHA." WHERE id_session='$id_session'");
      $query->execute() or die("     !");
      my $row = $query->fetchrow_hashref();
      my $captcha_securityCode = $row->{securityCode};
        
      if($captcha_securityCode ne $securityCode)
      {
         $action = "";
         $error[5] = $error[5]."   !";
      }
      
      #  
      $query->finish();           
   }

   #      
   if($msg ne '')
   {
      my @string = split('\s+', $msg);

      while(@string)
      {             
         $string = shift @string;

         if(int(length($string))>60)
         {
            $action = ""; 
            $error[2] = $error[2]."  <br>    . ";
            break;
         }
      }

      if(int(length($msg))>int($row_setting->{msg_len}))
      {
         $action = "";
         $error[2] = $error[2]."    $set_msg_len !";
      }
   }

   #   \n  \r    <br />
   $msg =~ s/\\n|\r/<br \/>/g;

   # ,     
   if($name eq '') 
   {
      $action = ""; 
      $error[1] = $error[1]."  !";
   }

   if($msg eq '') 
   {
      $action = ""; 
      $error[2] = $error[2]." !";
   }

   if($row_setting->{security} eq 'yes' and $securityCode eq '')
   {
      $action = ""; 
      $error[5] = $error[5]."  !";   
   }   

   #   ,      
   if($error[1] eq '' and $error[2] eq '' and $error[3] eq '' and $error[4] eq '' and $error[5] eq '')
   {
      #  
      my $reg = '\w{0,5}[x]([x\s\!@#\$%\^&*+-\|\/]{0,6})[y]([y\s\!@#\$%\^&*+-\|\/]{0,6})[ie]\w{0,7}|\w{0,6}[p]([p\s\!@#\$%\^&*+-\|\/]{0,6})[i]([i\s\!@#\$%\^&*+-\|\/]{0,6})[3]([3\s\!@#\$%\^&*+-\|\/]{0,6})[d]\w{0,10}|[cs][y]([y\!@#\$%\^&*+-\|\/]{0,6})[4k]\w{1,3}|\w{0,4}[b]([b\s\!@#\$%\^&*+-\|\/]{0,6})[l]([l\s\!@#\$%\^&*+-\|\/]{0,6})[y]\w{0,10}|\w{0,8}[][b][@ea][@]\w{0,8}|\w{0,4}[e]([e\s\!@#\$%\^&*+-\|\/]{0,6})[b]([b\s\!@#\$%\^&*+-\|\/]{0,6})[u]([u\s\!@#\$%\^&*+-\|\/]{0,6})[4]\w{0,4}|\w{0,4}[e]([e\s\!@#\$%\^&*+-\|\/]{0,6})[b]([b\s\!@#\$%\^&*+-\|\/]{0,6})[n]([n\s\!@#\$%\^&*+-\|\/]{0,6})[y]\w{0,4}|\w{0,4}[e]([e\s\!@#\$%\^&*+-\|\/]{0,6})[b]([b\s\!@#\$%\^&*+-\|\/]{0,6})[oa@]([oa@\s\!@#\$%\^&*+-\|\/]{0,6})[nt]\w{0,4}|\w{0,10}[]([\!@#\$%\^&*+-\|\/]{0,6})[]\w{0,6}|\w{0,4}[p]([p\s\!@#\$%\^&*+-\|\/]{0,6})[ei]([ei\s\!@#\$%\^&*+-\|\/]{0,6})[d]([d\s\!@#\$%\^&*+-\|\/]{0,6})[oa@ei]([oa@ei\s\!@#\$%\^&*+-\|\/]{0,6})[r]\w{0,12}';
      my $replace = '<font color=red><><\/font>';

      if($row_setting->{antimat} eq 'yes')
      {
         $name =~ s/$reg/$replace/gi;
         $msg  =~ s/$reg/$replace/gi;
         $city =~ s/$reg/$replace/gi;
      }

      #     html
      $msg =~ s/\\n//g;
      $msg =~ s/\\r//g;
      $msg =~ s/\[b\]/<b>/g;
      $msg =~ s/\[\/b\]/<\/b>/g;
      $msg =~ s/\[i\]/<i>/g;
      $msg =~ s/\[\/i\]/<\/i>/g;
      $msg =~ s/\[u\]/<u>/g;
      $msg =~ s/\[\/u\]/<\/u>/g;
      $msg =~ s/\[s\]/<s>/g;
      $msg =~ s/\[\/s\]/<\/s>/g;
      $msg =~ s/\[p right\]/<p align=right>/g;
      $msg =~ s/\[p center\]/<p align=center>/g;
      $msg =~ s/\[p left\]/<p align=left>/g;
      $msg =~ s/\[p justify\]/<p align=justify>/g;
      $msg =~ s/\[\/p\]/<\/p>/g;
      $msg =~ s/\[font/<font/g;
      $msg =~ s/\[\/font\]/<\/font>/g;
      $msg =~ s/\#\]/>/g;

      #     
      $name  = invert_comas($name);
      $email = invert_comas($email);
      $url   = invert_comas($url);
      $msg   = invert_comas($msg);
      $city  = invert_comas($city);
 
      if($row_setting->{moder} eq 'yes') { $hide = "hide"; }
      else { $hide = "show"; }

      my $time_add = strftime("%Y-%m-%d %I:%M:%S", localtime);

      #     
      my $query = $dbh->prepare("INSERT INTO ".Constants::DB_MSG." VALUES (0,'$name','$msg','$city','$email','$url','$ip','','$time_add','$hide')");
      $query->execute() or die("     ! $name $msg $city $email $url $ip $time_add $hide");

      #     send   yes,       
      if($row_setting->{send} eq 'yes')
      {
         #      /usr/sbin/sendmail      sendmail
         # ,         ,       
         open (MAIL, "| /usr/sbin/sendmail -t");
         print MAIL "Content-Type: text/plain; charset=windows-1251\n";
         print MAIL "From: admin@".$ENV{'SERVER_NAME'}."\n";
         print MAIL "To: ".$row_setting->{email}."\n";
         print MAIL "Subject:      $ENV{'SERVER_NAME'}\r\n";
         print MAIL "    \n";
         print MAIL ": $name\n";

	 if($mail ne '') { print MAIL "Email: $mail\n"; }
	 print MAIL ": $msg\n";
		   
	 close (MAIL);
      } 
      
      #  
      $query->finish();

      #     
      print "<HTML><HEAD>\n";
      print "<META HTTP-EQUIV='Refresh' CONTENT='3; URL=index.pl'>\n";

      if($row_setting->{moder} eq 'yes')
      { 
         print "</HEAD><BODY><CENTER>,   !<br>        .</CENTER></BODY></HTML>\n";
      }
      else
      { 
         print "</HEAD><BODY><CENTER>,   !</CENTER></BODY></HTML>\n";
      }
   }
}

if($action eq '')
{

   # 
   require 'lib/_top.pl' or die('   "_top.pl"');

print <<HTML1;
<script type=text/javascript src="http://$ENV{"SERVER_NAME"}/panel.js"></script>

<h2> </h2>
<p>&lt;&lt; <a href="index.pl" title="   ">   </a></p>
<form method="POST" name=form action="$ENV{'SCRIPT_NAME'}">
<table class="table" border="0">
<tr>
  <td colspan="2"><p><font class="error">*</font>    .</p></td>
</tr>
<tr>
  <td width="145"><p> :<font class="error">*$error[1]</font></p></td>
  <td><input type="text" name="name" class="input" size="25" value='$name'></td>
</tr>
<tr>
  <td width="145"><p>E-mail :<font class="error">$error[3]</font></p></td>
  <td><input type="text" name="email" class="input" size="25" value='$email'></td>
</tr>
<tr>
  <td width="145"><p> :</p></td>
  <td><input type="text" name="city" class="input" size="25" value='$city'></td>
</tr>
<tr>
  <td width="145"><p>:<font class="error">$error[4]</font></p></td>
  <td><input type="text" name="url" class="input" size="25" value='$url'></td>
</tr>
<tr>
  <td colspan="2"><table cellpadding="3" cellPadding=8 width="100%" border="0">
<tr>
  <td vAlign=top><p class=artcode> <a href="javascript:justReturn();"><IMG onclick='xoopsCodeBold("filedesc");' alt="" border="0" src="http://$ENV{ "SERVER_NAME" }/images/bold.gif"></a> <a href="javascript:justReturn();"><IMG onclick='xoopsCodeItalic("filedesc");' alt="" border="0" src="http://$ENV{ "SERVER_NAME" }/images/italic.gif"></a> <a href="javascript:justReturn();"><IMG onclick='xoopsCodeUnderline("filedesc");' alt="" border="0" src="http://$ENV{ "SERVER_NAME" }/images/underline.gif"></a> <a href="javascript:justReturn();"><IMG onclick='xoopsCodeStrike("filedesc");' alt="" border="0" src="http://$ENV{ "SERVER_NAME" }/images/strike.gif"></a>&nbsp;&nbsp;&nbsp; <a href="javascript:justReturn();"><IMG onclick='xoopsCodeRight("filedesc");' alt="" border="0" src="http://$ENV{ "SERVER_NAME" }/images/right.gif"></a> <a href="javascript:justReturn();"><IMG onclick='xoopsCodeCenter("filedesc");' alt=" " border="0" src="http://$ENV{ "SERVER_NAME" }/images/center.gif"></a> <a href="javascript:justReturn();"><IMG onclick='xoopsCodeLeft("filedesc");' alt="" border="0" src="http://$ENV{ "SERVER_NAME" }/images/left.gif"></a> <a href="javascript:justReturn();"><IMG onclick='xoopsCodeJustify("filedesc");' alt=" " border="0" src="http://$ENV{ "SERVER_NAME" }/images/justify.gif"></a>&nbsp;&nbsp;&nbsp;
      <select class=select id=filedescSize onchange='xoopsCodeSize("filedesc");'>
        <option value=SIZE selected></option>
        <option value=1>xx-small</option>
        <option value=2>x-small</option>
        <option value=3>small</option>
        <option value=4>medium</option>
        <option value=5>large</option>
        <option value=6>x-large</option>
        <option value=7>xx-large</option>
      </select>
      <select class=select id=filedescFont onchange='xoopsCodeFont("filedesc");'>
        <option value=FONT selected></option>
        <option value="Arabic Transparent">Arabic Transparent</option>
        <option value=Arial>Arial</option>
        <option value="Comic Sans MS">Comic Sans MS</option>
        <option value=Courier>Courier</option>
        <option value=Georgia>Georgia</option>
        <option value=Helvetica>Helvetica</option>
        <option value=Impact>Impact</option>
        <option value="MS Sans Serif">MS Sans Serif</option>
        <option value="Monotype Corsiva">Monotype Corsiva</option>
        <option value="Simplified Arabic">Simplified Arabic</option>
        <option value=Tahoma>Tahoma</option>
        <option value="Times New Roman">Times New Roman</option>
        <option value="Traditional Arabic">Traditional Arabic</option>
        <option value=Verdana>Verdana</option>
        <option value=Wingdings>Wingdings</option>
        <option value="Wingdings 2">Wingdings 2</option>
        <option value="Wingdings 3">Wingdings 3</option>
      </select>
      <select class=select id=filedescColor onchange='xoopsCodeColor("filedesc");'>
        <option value=COLOR selected></option>
        <option style="COLOR: #000000; BACKGROUND-COLOR: #000000" value=000000>#000000</option>
        <option style="COLOR: #000033; BACKGROUND-COLOR: #000033" value=000033>#000033</option>
        <option style="COLOR: #000066; BACKGROUND-COLOR: #000066" value=000066>#000066</option>
        <option style="COLOR: #000099; BACKGROUND-COLOR: #000099" value=000099>#000099</option>
        <option style="COLOR: #0000cc; BACKGROUND-COLOR: #0000cc" value=0000CC>#0000CC</option>
        <option style="COLOR: #0000ff; BACKGROUND-COLOR: #0000ff" value=0000FF>#0000FF</option>
        <option style="COLOR: #003300; BACKGROUND-COLOR: #003300" value=003300>#003300</option>
        <option style="COLOR: #003333; BACKGROUND-COLOR: #003333" value=003333>#003333</option>
        <option style="COLOR: #003366; BACKGROUND-COLOR: #003366" value=003366>#003366</option>
        <option style="COLOR: #003399; BACKGROUND-COLOR: #003399" value=003399>#003399</option>
        <option style="COLOR: #0033cc; BACKGROUND-COLOR: #0033cc" value=0033CC>#0033CC</option>
        <option style="COLOR: #0033ff; BACKGROUND-COLOR: #0033ff" value=0033FF>#0033FF</option>
        <option style="COLOR: #006600; BACKGROUND-COLOR: #006600" value=006600>#006600</option>
        <option style="COLOR: #006633; BACKGROUND-COLOR: #006633" value=006633>#006633</option>
        <option style="COLOR: #006666; BACKGROUND-COLOR: #006666" value=006666>#006666</option>
        <option style="COLOR: #006699; BACKGROUND-COLOR: #006699" value=006699>#006699</option>
        <option style="COLOR: #0066cc; BACKGROUND-COLOR: #0066cc" value=0066CC>#0066CC</option>
        <option style="COLOR: #0066ff; BACKGROUND-COLOR: #0066ff" value=0066FF>#0066FF</option>
        <option style="COLOR: #009900; BACKGROUND-COLOR: #009900" value=009900>#009900</option>
        <option style="COLOR: #009933; BACKGROUND-COLOR: #009933" value=009933>#009933</option>
        <option style="COLOR: #009966; BACKGROUND-COLOR: #009966" value=009966>#009966</option>
        <option style="COLOR: #009999; BACKGROUND-COLOR: #009999" value=009999>#009999</option>
        <option style="COLOR: #0099cc; BACKGROUND-COLOR: #0099cc" value=0099CC>#0099CC</option>
        <option style="COLOR: #0099ff; BACKGROUND-COLOR: #0099ff" value=0099FF>#0099FF</option>
        <option style="COLOR: #00cc00; BACKGROUND-COLOR: #00cc00" value=00CC00>#00CC00</option>
        <option style="COLOR: #00cc33; BACKGROUND-COLOR: #00cc33" value=00CC33>#00CC33</option>
        <option style="COLOR: #00cc66; BACKGROUND-COLOR: #00cc66" value=00CC66>#00CC66</option>
        <option style="COLOR: #00cc99; BACKGROUND-COLOR: #00cc99" value=00CC99>#00CC99</option>
        <option style="COLOR: #00cccc; BACKGROUND-COLOR: #00cccc" value=00CCCC>#00CCCC</option>
        <option style="COLOR: #00ccff; BACKGROUND-COLOR: #00ccff" value=00CCFF>#00CCFF</option>
        <option style="COLOR: #00ff00; BACKGROUND-COLOR: #00ff00" value=00FF00>#00FF00</option>
        <option style="COLOR: #00ff33; BACKGROUND-COLOR: #00ff33" value=00FF33>#00FF33</option>
        <option style="COLOR: #00ff66; BACKGROUND-COLOR: #00ff66" value=00FF66>#00FF66</option>
        <option style="COLOR: #00ff99; BACKGROUND-COLOR: #00ff99" value=00FF99>#00FF99</option>
        <option style="COLOR: #00ffcc; BACKGROUND-COLOR: #00ffcc" value=00FFCC>#00FFCC</option>
        <option style="COLOR: #00ffff; BACKGROUND-COLOR: #00ffff" value=00FFFF>#00FFFF</option>
        <option style="COLOR: #330000; BACKGROUND-COLOR: #330000" value=330000>#330000</option>
        <option style="COLOR: #330033; BACKGROUND-COLOR: #330033" value=330033>#330033</option>
        <option style="COLOR: #330066; BACKGROUND-COLOR: #330066" value=330066>#330066</option>
        <option style="COLOR: #330099; BACKGROUND-COLOR: #330099" value=330099>#330099</option>
        <option style="COLOR: #3300cc; BACKGROUND-COLOR: #3300cc" value=3300CC>#3300CC</option>
        <option style="COLOR: #3300ff; BACKGROUND-COLOR: #3300ff" value=3300FF>#3300FF</option>
        <option style="COLOR: #333300; BACKGROUND-COLOR: #333300" value=333300>#333300</option>
        <option style="COLOR: #333333; BACKGROUND-COLOR: #333333" value=333333>#333333</option>
        <option style="COLOR: #333366; BACKGROUND-COLOR: #333366" value=333366>#333366</option>
        <option style="COLOR: #333399; BACKGROUND-COLOR: #333399" value=333399>#333399</option>
        <option style="COLOR: #3333cc; BACKGROUND-COLOR: #3333cc" value=3333CC>#3333CC</option>
        <option style="COLOR: #3333ff; BACKGROUND-COLOR: #3333ff" value=3333FF>#3333FF</option>
        <option style="COLOR: #336600; BACKGROUND-COLOR: #336600" value=336600>#336600</option>
        <option style="COLOR: #336633; BACKGROUND-COLOR: #336633" value=336633>#336633</option>
        <option style="COLOR: #336666; BACKGROUND-COLOR: #336666" value=336666>#336666</option>
        <option style="COLOR: #336699; BACKGROUND-COLOR: #336699" value=336699>#336699</option>
        <option style="COLOR: #3366cc; BACKGROUND-COLOR: #3366cc" value=3366CC>#3366CC</option>
        <option style="COLOR: #3366ff; BACKGROUND-COLOR: #3366ff" value=3366FF>#3366FF</option>
        <option style="COLOR: #339900; BACKGROUND-COLOR: #339900" value=339900>#339900</option>
        <option style="COLOR: #339933; BACKGROUND-COLOR: #339933" value=339933>#339933</option>
        <option style="COLOR: #339966; BACKGROUND-COLOR: #339966" value=339966>#339966</option>
        <option style="COLOR: #339999; BACKGROUND-COLOR: #339999" value=339999>#339999</option>
        <option style="COLOR: #3399cc; BACKGROUND-COLOR: #3399cc" value=3399CC>#3399CC</option>
        <option style="COLOR: #3399ff; BACKGROUND-COLOR: #3399ff" value=3399FF>#3399FF</option>
        <option style="COLOR: #33cc00; BACKGROUND-COLOR: #33cc00" value=33CC00>#33CC00</option>
        <option style="COLOR: #33cc33; BACKGROUND-COLOR: #33cc33" value=33CC33>#33CC33</option>
        <option style="COLOR: #33cc66; BACKGROUND-COLOR: #33cc66" value=33CC66>#33CC66</option>
        <option style="COLOR: #33cc99; BACKGROUND-COLOR: #33cc99" value=33CC99>#33CC99</option>
        <option style="COLOR: #33cccc; BACKGROUND-COLOR: #33cccc" value=33CCCC>#33CCCC</option>
        <option style="COLOR: #33ccff; BACKGROUND-COLOR: #33ccff" value=33CCFF>#33CCFF</option>
        <option style="COLOR: #33ff00; BACKGROUND-COLOR: #33ff00" value=33FF00>#33FF00</option>
        <option style="COLOR: #33ff33; BACKGROUND-COLOR: #33ff33" value=33FF33>#33FF33</option>
        <option style="COLOR: #33ff66; BACKGROUND-COLOR: #33ff66" value=33FF66>#33FF66</option>
        <option style="COLOR: #33ff99; BACKGROUND-COLOR: #33ff99" value=33FF99>#33FF99</option>
        <option style="COLOR: #33ffcc; BACKGROUND-COLOR: #33ffcc" value=33FFCC>#33FFCC</option>
        <option style="COLOR: #33ffff; BACKGROUND-COLOR: #33ffff" value=33FFFF>#33FFFF</option>
        <option style="COLOR: #660000; BACKGROUND-COLOR: #660000" value=660000>#660000</option>
        <option style="COLOR: #660033; BACKGROUND-COLOR: #660033" value=660033>#660033</option>
        <option style="COLOR: #660066; BACKGROUND-COLOR: #660066" value=660066>#660066</option>
        <option style="COLOR: #660099; BACKGROUND-COLOR: #660099" value=660099>#660099</option>
        <option style="COLOR: #6600cc; BACKGROUND-COLOR: #6600cc" value=6600CC>#6600CC</option>
        <option style="COLOR: #6600ff; BACKGROUND-COLOR: #6600ff" value=6600FF>#6600FF</option>
        <option style="COLOR: #663300; BACKGROUND-COLOR: #663300" value=663300>#663300</option>
        <option style="COLOR: #663333; BACKGROUND-COLOR: #663333" value=663333>#663333</option>
        <option style="COLOR: #663366; BACKGROUND-COLOR: #663366" value=663366>#663366</option>
        <option style="COLOR: #663399; BACKGROUND-COLOR: #663399" value=663399>#663399</option>
        <option style="COLOR: #6633cc; BACKGROUND-COLOR: #6633cc" value=6633CC>#6633CC</option>
        <option style="COLOR: #6633ff; BACKGROUND-COLOR: #6633ff" value=6633FF>#6633FF</option>
        <option style="COLOR: #666600; BACKGROUND-COLOR: #666600" value=666600>#666600</option>
        <option style="COLOR: #666633; BACKGROUND-COLOR: #666633" value=666633>#666633</option>
        <option style="COLOR: #666666; BACKGROUND-COLOR: #666666" value=666666>#666666</option>
        <option style="COLOR: #666699; BACKGROUND-COLOR: #666699" value=666699>#666699</option>
        <option style="COLOR: #6666cc; BACKGROUND-COLOR: #6666cc" value=6666CC>#6666CC</option>
        <option style="COLOR: #6666ff; BACKGROUND-COLOR: #6666ff" value=6666FF>#6666FF</option>
        <option style="COLOR: #669900; BACKGROUND-COLOR: #669900" value=669900>#669900</option>
        <option style="COLOR: #669933; BACKGROUND-COLOR: #669933" value=669933>#669933</option>
        <option style="COLOR: #669966; BACKGROUND-COLOR: #669966" value=669966>#669966</option>
        <option style="COLOR: #669999; BACKGROUND-COLOR: #669999" value=669999>#669999</option>
        <option style="COLOR: #6699cc; BACKGROUND-COLOR: #6699cc" value=6699CC>#6699CC</option>
        <option style="COLOR: #6699ff; BACKGROUND-COLOR: #6699ff" value=6699FF>#6699FF</option>
        <option style="COLOR: #66cc00; BACKGROUND-COLOR: #66cc00" value=66CC00>#66CC00</option>
        <option style="COLOR: #66cc33; BACKGROUND-COLOR: #66cc33" value=66CC33>#66CC33</option>
        <option style="COLOR: #66cc66; BACKGROUND-COLOR: #66cc66" value=66CC66>#66CC66</option>
        <option style="COLOR: #66cc99; BACKGROUND-COLOR: #66cc99" value=66CC99>#66CC99</option>
        <option style="COLOR: #66cccc; BACKGROUND-COLOR: #66cccc" value=66CCCC>#66CCCC</option>
        <option style="COLOR: #66ccff; BACKGROUND-COLOR: #66ccff" value=66CCFF>#66CCFF</option>
        <option style="COLOR: #66ff00; BACKGROUND-COLOR: #66ff00" value=66FF00>#66FF00</option>
        <option style="COLOR: #66ff33; BACKGROUND-COLOR: #66ff33" value=66FF33>#66FF33</option>
        <option style="COLOR: #66ff66; BACKGROUND-COLOR: #66ff66" value=66FF66>#66FF66</option>
        <option style="COLOR: #66ff99; BACKGROUND-COLOR: #66ff99" value=66FF99>#66FF99</option>
        <option style="COLOR: #66ffcc; BACKGROUND-COLOR: #66ffcc" value=66FFCC>#66FFCC</option>
        <option style="COLOR: #66ffff; BACKGROUND-COLOR: #66ffff" value=66FFFF>#66FFFF</option>
        <option style="COLOR: #990000; BACKGROUND-COLOR: #990000" value=990000>#990000</option>
        <option style="COLOR: #990033; BACKGROUND-COLOR: #990033" value=990033>#990033</option>
        <option style="COLOR: #990066; BACKGROUND-COLOR: #990066" value=990066>#990066</option>
        <option style="COLOR: #990099; BACKGROUND-COLOR: #990099" value=990099>#990099</option>
        <option style="COLOR: #9900cc; BACKGROUND-COLOR: #9900cc" value=9900CC>#9900CC</option>
        <option style="COLOR: #9900ff; BACKGROUND-COLOR: #9900ff" value=9900FF>#9900FF</option>
        <option style="COLOR: #993300; BACKGROUND-COLOR: #993300" value=993300>#993300</option>
        <option style="COLOR: #993333; BACKGROUND-COLOR: #993333" value=993333>#993333</option>
        <option style="COLOR: #993366; BACKGROUND-COLOR: #993366" value=993366>#993366</option>
        <option style="COLOR: #993399; BACKGROUND-COLOR: #993399" value=993399>#993399</option>
        <option style="COLOR: #9933cc; BACKGROUND-COLOR: #9933cc" value=9933CC>#9933CC</option>
        <option style="COLOR: #9933ff; BACKGROUND-COLOR: #9933ff" value=9933FF>#9933FF</option>
        <option style="COLOR: #996600; BACKGROUND-COLOR: #996600" value=996600>#996600</option>
        <option style="COLOR: #996633; BACKGROUND-COLOR: #996633" value=996633>#996633</option>
        <option style="COLOR: #996666; BACKGROUND-COLOR: #996666" value=996666>#996666</option>
        <option style="COLOR: #996699; BACKGROUND-COLOR: #996699" value=996699>#996699</option>
        <option style="COLOR: #9966cc; BACKGROUND-COLOR: #9966cc" value=9966CC>#9966CC</option>
        <option style="COLOR: #9966ff; BACKGROUND-COLOR: #9966ff" value=9966FF>#9966FF</option>
        <option style="COLOR: #999900; BACKGROUND-COLOR: #999900" value=999900>#999900</option>
        <option style="COLOR: #999933; BACKGROUND-COLOR: #999933" value=999933>#999933</option>
        <option style="COLOR: #999966; BACKGROUND-COLOR: #999966" value=999966>#999966</option>
        <option style="COLOR: #999999; BACKGROUND-COLOR: #999999" value=999999>#999999</option>
        <option style="COLOR: #9999cc; BACKGROUND-COLOR: #9999cc" value=9999CC>#9999CC</option>
        <option style="COLOR: #9999ff; BACKGROUND-COLOR: #9999ff" value=9999FF>#9999FF</option>
        <option style="COLOR: #99cc00; BACKGROUND-COLOR: #99cc00" value=99CC00>#99CC00</option>
        <option style="COLOR: #99cc33; BACKGROUND-COLOR: #99cc33" value=99CC33>#99CC33</option>
        <option style="COLOR: #99cc66; BACKGROUND-COLOR: #99cc66" value=99CC66>#99CC66</option>
        <option style="COLOR: #99cc99; BACKGROUND-COLOR: #99cc99" value=99CC99>#99CC99</option>
        <option style="COLOR: #99cccc; BACKGROUND-COLOR: #99cccc" value=99CCCC>#99CCCC</option>
        <option style="COLOR: #99ccff; BACKGROUND-COLOR: #99ccff" value=99CCFF>#99CCFF</option>
        <option style="COLOR: #99ff00; BACKGROUND-COLOR: #99ff00" value=99FF00>#99FF00</option>
        <option style="COLOR: #99ff33; BACKGROUND-COLOR: #99ff33" value=99FF33>#99FF33</option>
        <option style="COLOR: #99ff66; BACKGROUND-COLOR: #99ff66" value=99FF66>#99FF66</option>
        <option style="COLOR: #99ff99; BACKGROUND-COLOR: #99ff99" value=99FF99>#99FF99</option>
        <option style="COLOR: #99ffcc; BACKGROUND-COLOR: #99ffcc" value=99FFCC>#99FFCC</option>
        <option style="COLOR: #99ffff; BACKGROUND-COLOR: #99ffff" value=99FFFF>#99FFFF</option>
        <option style="COLOR: #cc0000; BACKGROUND-COLOR: #cc0000" value=CC0000>#CC0000</option>
        <option style="COLOR: #cc0033; BACKGROUND-COLOR: #cc0033" value=CC0033>#CC0033</option>
        <option style="COLOR: #cc0066; BACKGROUND-COLOR: #cc0066" value=CC0066>#CC0066</option>
        <option style="COLOR: #cc0099; BACKGROUND-COLOR: #cc0099" value=CC0099>#CC0099</option>
        <option style="COLOR: #cc00cc; BACKGROUND-COLOR: #cc00cc" value=CC00CC>#CC00CC</option>
        <option style="COLOR: #cc00ff; BACKGROUND-COLOR: #cc00ff" value=CC00FF>#CC00FF</option>
        <option style="COLOR: #cc3300; BACKGROUND-COLOR: #cc3300" value=CC3300>#CC3300</option>
        <option style="COLOR: #cc3333; BACKGROUND-COLOR: #cc3333" value=CC3333>#CC3333</option>
        <option style="COLOR: #cc3366; BACKGROUND-COLOR: #cc3366" value=CC3366>#CC3366</option>
        <option style="COLOR: #cc3399; BACKGROUND-COLOR: #cc3399" value=CC3399>#CC3399</option>
        <option style="COLOR: #cc33cc; BACKGROUND-COLOR: #cc33cc" value=CC33CC>#CC33CC</option>
        <option style="COLOR: #cc33ff; BACKGROUND-COLOR: #cc33ff" value=CC33FF>#CC33FF</option>
        <option style="COLOR: #cc6600; BACKGROUND-COLOR: #cc6600" value=CC6600>#CC6600</option>
        <option style="COLOR: #cc6633; BACKGROUND-COLOR: #cc6633" value=CC6633>#CC6633</option>
        <option style="COLOR: #cc6666; BACKGROUND-COLOR: #cc6666" value=CC6666>#CC6666</option>
        <option style="COLOR: #cc6699; BACKGROUND-COLOR: #cc6699" value=CC6699>#CC6699</option>
        <option style="COLOR: #cc66cc; BACKGROUND-COLOR: #cc66cc" value=CC66CC>#CC66CC</option>
        <option style="COLOR: #cc66ff; BACKGROUND-COLOR: #cc66ff" value=CC66FF>#CC66FF</option>
        <option style="COLOR: #cc9900; BACKGROUND-COLOR: #cc9900" value=CC9900>#CC9900</option>
        <option style="COLOR: #cc9933; BACKGROUND-COLOR: #cc9933" value=CC9933>#CC9933</option>
        <option style="COLOR: #cc9966; BACKGROUND-COLOR: #cc9966" value=CC9966>#CC9966</option>
        <option style="COLOR: #cc9999; BACKGROUND-COLOR: #cc9999" value=CC9999>#CC9999</option>
        <option style="COLOR: #cc99cc; BACKGROUND-COLOR: #cc99cc" value=CC99CC>#CC99CC</option>
        <option style="COLOR: #cc99ff; BACKGROUND-COLOR: #cc99ff" value=CC99FF>#CC99FF</option>
        <option style="COLOR: #cccc00; BACKGROUND-COLOR: #cccc00" value=CCCC00>#CCCC00</option>
        <option style="COLOR: #cccc33; BACKGROUND-COLOR: #cccc33" value=CCCC33>#CCCC33</option>
        <option style="COLOR: #cccc66; BACKGROUND-COLOR: #cccc66" value=CCCC66>#CCCC66</option>
        <option style="COLOR: #cccc99; BACKGROUND-COLOR: #cccc99" value=CCCC99>#CCCC99</option>
        <option style="COLOR: #cccccc; BACKGROUND-COLOR: #cccccc" value=CCCCCC>#CCCCCC</option>
        <option style="COLOR: #ccccff; BACKGROUND-COLOR: #ccccff" value=CCCCFF>#CCCCFF</option>
        <option style="COLOR: #ccff00; BACKGROUND-COLOR: #ccff00" value=CCFF00>#CCFF00</option>
        <option style="COLOR: #ccff33; BACKGROUND-COLOR: #ccff33" value=CCFF33>#CCFF33</option>
        <option style="COLOR: #ccff66; BACKGROUND-COLOR: #ccff66" value=CCFF66>#CCFF66</option>
        <option style="COLOR: #ccff99; BACKGROUND-COLOR: #ccff99" value=CCFF99>#CCFF99</option>
        <option style="COLOR: #ccffcc; BACKGROUND-COLOR: #ccffcc" value=CCFFCC>#CCFFCC</option>
        <option style="COLOR: #ccffff; BACKGROUND-COLOR: #ccffff" value=CCFFFF>#CCFFFF</option>
        <option style="COLOR: #ff0000; BACKGROUND-COLOR: #ff0000" value=FF0000>#FF0000</option>
        <option style="COLOR: #ff0033; BACKGROUND-COLOR: #ff0033" value=FF0033>#FF0033</option>
        <option style="COLOR: #ff0066; BACKGROUND-COLOR: #ff0066" value=FF0066>#FF0066</option>
        <option style="COLOR: #ff0099; BACKGROUND-COLOR: #ff0099" value=FF0099>#FF0099</option>
        <option style="COLOR: #ff00cc; BACKGROUND-COLOR: #ff00cc" value=FF00CC>#FF00CC</option>
        <option style="COLOR: #ff00ff; BACKGROUND-COLOR: #ff00ff" value=FF00FF>#FF00FF</option>
        <option style="COLOR: #ff3300; BACKGROUND-COLOR: #ff3300" value=FF3300>#FF3300</option>
        <option style="COLOR: #ff3333; BACKGROUND-COLOR: #ff3333" value=FF3333>#FF3333</option>
        <option style="COLOR: #ff3366; BACKGROUND-COLOR: #ff3366" value=FF3366>#FF3366</option>
        <option style="COLOR: #ff3399; BACKGROUND-COLOR: #ff3399" value=FF3399>#FF3399</option>
        <option style="COLOR: #ff33cc; BACKGROUND-COLOR: #ff33cc" value=FF33CC>#FF33CC</option>
        <option style="COLOR: #ff33ff; BACKGROUND-COLOR: #ff33ff" value=FF33FF>#FF33FF</option>
        <option style="COLOR: #ff6600; BACKGROUND-COLOR: #ff6600" value=FF6600>#FF6600</option>
        <option style="COLOR: #ff6633; BACKGROUND-COLOR: #ff6633" value=FF6633>#FF6633</option>
        <option style="COLOR: #ff6666; BACKGROUND-COLOR: #ff6666" value=FF6666>#FF6666</option>
        <option style="COLOR: #ff6699; BACKGROUND-COLOR: #ff6699" value=FF6699>#FF6699</option>
        <option style="COLOR: #ff66cc; BACKGROUND-COLOR: #ff66cc" value=FF66CC>#FF66CC</option>
        <option style="COLOR: #ff66ff; BACKGROUND-COLOR: #ff66ff" value=FF66FF>#FF66FF</option>
        <option style="COLOR: #ff9900; BACKGROUND-COLOR: #ff9900" value=FF9900>#FF9900</option>
        <option style="COLOR: #ff9933; BACKGROUND-COLOR: #ff9933" value=FF9933>#FF9933</option>
        <option style="COLOR: #ff9966; BACKGROUND-COLOR: #ff9966" value=FF9966>#FF9966</option>
        <option style="COLOR: #ff9999; BACKGROUND-COLOR: #ff9999" value=FF9999>#FF9999</option>
        <option style="COLOR: #ff99cc; BACKGROUND-COLOR: #ff99cc" value=FF99CC>#FF99CC</option>
        <option style="COLOR: #ff99ff; BACKGROUND-COLOR: #ff99ff" value=FF99FF>#FF99FF</option>
        <option style="COLOR: #ffcc00; BACKGROUND-COLOR: #ffcc00" value=FFCC00>#FFCC00</option>
        <option style="COLOR: #ffcc33; BACKGROUND-COLOR: #ffcc33" value=FFCC33>#FFCC33</option>
        <option style="COLOR: #ffcc66; BACKGROUND-COLOR: #ffcc66" value=FFCC66>#FFCC66</option>
        <option style="COLOR: #ffcc99; BACKGROUND-COLOR: #ffcc99" value=FFCC99>#FFCC99</option>
        <option style="COLOR: #ffcccc; BACKGROUND-COLOR: #ffcccc" value=FFCCCC>#FFCCCC</option>
        <option style="COLOR: #ffccff; BACKGROUND-COLOR: #ffccff" value=FFCCFF>#FFCCFF</option>
        <option style="COLOR: #ffff00; BACKGROUND-COLOR: #ffff00" value=FFFF00>#FFFF00</option>
        <option style="COLOR: #ffff33; BACKGROUND-COLOR: #ffff33" value=FFFF33>#FFFF33</option>
        <option style="COLOR: #ffff66; BACKGROUND-COLOR: #ffff66" value=FFFF66>#FFFF66</option>
        <option style="COLOR: #ffff99; BACKGROUND-COLOR: #ffff99" value=FFFF99>#FFFF99</option>
        <option style="COLOR: #ffffcc; BACKGROUND-COLOR: #ffffcc" value=FFFFCC>#FFFFCC</option>
        <option style="COLOR: #ffffff; BACKGROUND-COLOR: #ffffff" value=FFFFFF>#FFFFFF</option>
      </select>
      <br>
      <br>
HTML1

    if($row_setting->{smile} eq 'yes')
    {

print <<HTML2;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_biggrin_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_biggrin.gif"></a>&nbsp;&nbsp;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_confused_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_confused.gif"></a>&nbsp;&nbsp;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_cool_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_cool.gif"></a>&nbsp;&nbsp;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_mad_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_mad.gif"></a>&nbsp;&nbsp;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_eek_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_eek.gif"></a>&nbsp;&nbsp;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_frown_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_frown.gif"></a>&nbsp;&nbsp;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_smile_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_smile.gif"></a>&nbsp;&nbsp;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_wink_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_wink.gif"></a>&nbsp;&nbsp;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_jazz_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_razz.gif"></a>&nbsp;&nbsp;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_blush_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_blush.gif"></a>&nbsp;&nbsp
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_cray_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_cray.gif"></a>&nbsp;&nbsp;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_dance_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_dance.gif"></a>&nbsp;&nbsp;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_drinks_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_drinks.gif"></a>&nbsp;&nbsp;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_fool_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_fool.gif"></a>&nbsp;&nbsp;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_good_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_good.gif"></a>&nbsp;&nbsp;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_kiss_mini_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_kiss_mini.gif"></a>&nbsp;&nbsp;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_man_in_love_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_man_in_love.gif"></a>&nbsp;&nbsp;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_rolleyes_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_rolleyes.gif"></a>&nbsp;&nbsp;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_scratch_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_scratch.gif"></a>&nbsp;&nbsp;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_shok_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_shok.gif"></a>&nbsp;&nbsp;
<a href="javascript:justReturn();"><IMG onclick='xoopsCode_shout_smile("filedesc");' border=0 src="http://$ENV{"SERVER_NAME"}/smile/icon_shout.gif"></a>&nbsp;&nbsp;
HTML2

    }

print <<HTML3;
        </td>
      </tr>
    </table>
  </td>
</tr>

<tr>
  <td width="145" valign="top"><font color="#FF0000">*$error[2]</font></td>
  <td><textarea rows="8" class="input2" id=filedesc name="msg" cols="40">$msg</textarea></td>
</tr>
HTML3

   if($row_setting->{security} eq 'yes')
   {
	   
print <<HTML4;
<tr>
   <td width="145"> :<font color="#FF0000">*$error[5]</font><br><img alt="   " class="input2" src="security.pl?id_session=$id_session" hspace="3"></td>
   <td><input type="text" class="input" name="securityCode" size="10"></td>
</tr>
HTML4

   }

print <<HTML5;
<tr>
   <td width="145"></td>
   <td><input type="submit" value=""> <input type="reset" value=""><input type=hidden name="action" value="post"></td>
</tr>
</table>
</form>
HTML5

   # 
   require 'lib/_bottom.pl' or die('   "_bottom.pl"');
}

#    
$dbh->disconnect();
